﻿package meyermike.minild10
{
    import flash.display.BlendMode;
    import flash.display.Sprite;
    import flash.geom.Point;
    import meyermike.constants.Colors;
    import meyermike.GameObject;
    import meyermike.Main;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Reddener extends GameObject
    {
        private var mGraphicsCreated:Boolean = false;

        public override function Init():void
        {
            super.Init();

            if (!mGraphicsCreated)
            {
                this.graphics.beginFill(Colors.DESAT_RED);
                this.graphics.drawRect(
                    0,
                    0,
                    Constants.STAGE_WIDTH,
                    Constants.STAGE_HEIGHT);
                this.graphics.endFill();
                this.blendMode = BlendMode.MULTIPLY;

                mGraphicsCreated = true;
            }

            Restart();
        }

        /**
         * called after all the final positions have been figured
         * just before drawing
         */
        public override function PreDraw():void
        {
            super.PreDraw();
            var camPos:Point = Main.sInstance.GetCameraPosition();
            this.x = camPos.x;
            this.y = camPos.y;
        }

        /**
         *
         */
        public function Restart():void
        {
            this.alpha = 0;
        }
    }

}
