﻿package meyermike.minild10
{
    import flash.geom.Point;
    import flash.geom.Rectangle;
    import meyermike.constants.Colors;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Constants
    {
        public static const GRAVITY:Number = 2000;
        public static const STAGE_WIDTH:Number = 480;
        public static const STAGE_HEIGHT:Number = 320;

        public static var PLAYER_COLOR:Number = Colors.DESAT_YELLOW;
        public static var ENEMY_COLOR:Number = Colors.DESAT_RED;
        public static var FRIENDLY_COLOR:Number = Colors.WHITE_ENOUGH;

        public static var PLAYER_WIDTH:Number = 20;
        public static var PLAYER_HEIGHT:Number = 40;
        public static const PLAYER_WALK_MAX_SPEED:Number = 300;
        public static const PLAYER_AIR_ACCEL:Number = PLAYER_WALK_MAX_SPEED * 2.0;
        public static const PLAYER_WALK_ACCEL:Number = PLAYER_WALK_MAX_SPEED * 1.0;
        public static const PLAYER_STOP_ACCEL:Number = PLAYER_WALK_MAX_SPEED * 3.0;
        public static const PLAYER_JUMP_SPEED:Number = 700;
        public static const PLAYER_JUMP_STOP_ACCEL:Number = PLAYER_JUMP_SPEED * 5.0;
        public static const NUM_AIR_JUMPS:Number = 1;

        public static const NPC_WALK_MAX_SPEED:Number = 100;
        public static const NPC_AIR_ACCEL:Number = 0.0;

        public static const ENEMY_JUMP_SPEED:Number = PLAYER_JUMP_SPEED;

        public static const PUNCH_DURATION:Number = 0.3;
        public static const PUNCH_MINSPEED:Number = 150;

        public static const DEATH_HOP_SPEED:Number = 200;
        public static const DEATH_ROTATION:Number = 720; // degrees / second
        public static const BLOOD_PARTICLES_PER_DEATH:Number = 50;

        public static const PUNCHED_ENEMY_VELOCITY:Point = new Point(700, -700);

        public static const PLATFORMS:Array = [
            new Rectangle(-500, 240, 1500, 10), // big floor
            new Rectangle(100, 160, 200, 10), // floating platform, left
            new Rectangle(500, 160, 200, 10), // floating platform, right
            ];
        public static const PLATFORM_COLOR:Number = 0x78C0C0;

        public static const REDDEN_STEP:Number = 0.25;

        public static const CHANCE_FOR_FAMILY_SPAWN:Number = 0.20;
        public static const CHANCE_FOR_TURN_ON_BEAT:Number = 0.25;

        public static const ZOOM_RATE:Number = 1.0; // magnification times per second.  (so 1 goes from 1x zoom to 2x zoom in one second)

        public static const SPAWN_AREA:Rectangle = new Rectangle(
            -100,
            0,
            700,
            0);
    }

}
