﻿package meyermike.minild9
{
    import flash.geom.Point;
    import flash.geom.Rectangle;
    import meyermike.constants.Colors;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Constants
    {
        public static const GRAVITY:Number = 1000;
        public static const STAGE_WIDTH:Number = 450;
        public static const STAGE_HEIGHT:Number = 250;

        public static const PLATFORMS:Array = [
            new Rectangle(50, 240, 800, 10), // big floor
            new Rectangle(100, 50, 140, 90), // big square
            new Rectangle(450, 220, 50, 10), // floating platform
            new Rectangle(300, 220, 50, 20), // wall to jump over
            new Rectangle(700, 160, 100, 20) // high platform
            ];

        public static const COLOR_BRIGHTEST:Number = 0xFFFFCC;
        public static const COLOR_BRIGHT:Number = 0xD5D5B3;
        public static const COLOR_MED:Number = 0xABAB9A;
        public static const COLOR_DARK:Number = 0x666652;
        public static const COLOR_DARKEST:Number = 0x303000;

        public static const PLATFORM_COLOR:Number   = Constants.COLOR_DARK;

        public static const PLAYER_WALK_SPEED:Number = 200;
        public static const PLAYER_JUMP_SPEED:Number = 300;
        public static const PLAYER_ENEMY_BOUNCE_SPEED:Number = 450;

        public static const TIME_LIMIT:Number = 1000.0; // in seconds
    }
}
